{$L+}
unit Register;

Interface

uses
  Objects, OMemory, OWindows,
  WinTypes,
  Strings,
  WinProcs,
  MyObject,
  WinMod1,
  WinMod3,
  MsgDial;
const
  ProgramCheck = '35801';
type
  WatchDogParam = (Open,Enroll,Verify);

  PFirstDialog = ^TFirstDialog;
  TFirstDialog = object(TCenteredDialog)

    constructor Init(AParent: PWindowsObject;
                      AName : PChar);
    procedure  SetupWindow;virtual;
    procedure  Initiate;virtual;
  end;

  PUnregDlg = ^TUnregDlg;
  TUnregDlg = object(TCenteredDialog)

   _ItemsLeft : integer;

    constructor Init(AParent   : PWindowsObject;
                     AName     : PChar;
                     ItemsLeft : integer);
    procedure  SetupWindow;virtual;
    procedure  IDCompleteReg(var Msg : TMessage);virtual
               id_First + id_CompleteReg;
    procedure  IDSendFee(var Msg : TMessage);virtual
               id_First + id_SendFee;
    procedure  IDWarranty(var Msg : TMessage);virtual
               id_First + id_Warranty;
  end;

  PCopyCheckDialog = ^TCopyCheckDialog;
  TCopyCheckDialog = object(TCenteredDialog)
    APage,
    ALine ,
    AWord : Integer;
    N     : Integer;
    constructor Init(AParent : PWindowsObject;AName:PChar;
                     Page,Line,Word : Integer;
                     WhichWord : Integer);
    procedure SetupWindow ; virtual;
    procedure  IDFlipReg(var Msg : TMessage);virtual
               id_First + id_FlipReg;
    procedure  OK(var Msg : TMessage);virtual id_First + id_OK;
  end;

  PPINCheckDialog = ^TPINCheckDialog;
  TPINCheckDialog = object(TCenteredDialog)
    constructor Init(AParent : PWindowsObject;AName:PChar);
    procedure SetupWindow ; virtual;
    procedure  IDFlipReg(var Msg : TMessage);virtual
               id_First + id_FlipReg;
    procedure OK(var Msg : TMessage);virtual id_First + id_OK;
  end;

Function CopyCheck(AParent : PWindowsObject;Param : WatchDogParam): boolean;
Function CalcPIN(InpName: var35string): var5string;

Implementation

 Type
  CheckInt  = Array[1..30,1..3] of integer;
  CheckStr  = Array[1..30] of string[11];

 Var
  UserName : var35string;
  UserPIN  : var35string;

 Const
  CheckVal : CheckInt = ((1,3,5),    {'TROUBLE',    }
                         (3,1,9),    {'CONTEXT',    }
                         (7,4,5),    {'GREATER',    }
                         (14,3,2),   {'REDUCES',    }
                         (17,1,1),   {'PERHAPS',    }
                         (23,1,2),   {'GRAPHICALLY',}
                         (27,1,3),   {'ALLOCATION', }
                         (31,1,5),   {'ALLOWS',     }
                         (32,3,7),   {'MONTHS',     }
                         (33,3,1),   {'SCROLLING',  }
                         (37,1,7),   {'HEADER',     }
                         (39,2,3),   {'RECORD',     }
                         (41,4,4),   {'COMBINED',   }
                         (45,2,3),   {'CHARGE',     }
                         (47,3,1),   {'SIMILARLY',  }
                         (51,5,5),   {'REDUCED',    }
                         (55,3,6),   {'VALUE',      }
                         (60,1,6),   {'INCORPORATE' }
                         (61,3,7),   {'WHETHER',    }
                         (63,2,1),   {'GENERAL',    }
                         (65,2,4),   {'APPEAR',     }
                         (69,4,5),   {'BALANCES',   }
                         (75,1,5),   {'HIGHLIGHT',  }
                         (78,1,3),   {'APPROACH',   }
                         (80,2,1),   {'PAYMENTS',   }
                         (83,2,3),   {'CHANGE',     }
                         (88,4,2),   {'KEEPING',    }
                         (93,4,3),   {'STEP',       }
                         (95,2,5),   {'CONCISE',    }
                         (99,4,7));  {'ACCESSED'    }

  CheckWord : CheckStr = ('TROUBLE','CONTEXT','GREATER','REDUCES',
                          'PERHAPS','GRAPHICALLY','ALLOCATION','ALLOWS',
                          'MONTHS','SCROLLING','HEADER','RECORD',
                          'COMBINED','CHARGE','SIMILARLY','REDUCED',
                          'VALUE','INCORPORATE','WHETHER','GENERAL',
                          'APPEAR','BALANCES','HIGHLIGHT','APPROACH',
                          'PAYMENTS','CHANGE','KEEPING','STEP',
                          'CONCISE','ACCESSED');

function WatchDog(Command,
                  PIN,
                  Name  : PChar) : boolean; far;
                                         external '$oneybox' index 1;

Function CopyCheck(AParent : PWindowsObject;Param : WatchDogParam): boolean;
var
 PCh : array[0..100] of char;
 N : integer;
Begin
 CopyCheck:=False;
 Case Param of
  Open     : Begin
              CopyCheck:=WatchDog('Open',ProgramCheck,'watchdog.txt');
             End;
  Enroll   : Begin
              If (PINCheck = 'YES')
               Then ReturnedRegType:=1
               Else ReturnedRegType:=2;
              Randomize;
              N:=0;
              While N = 0 do
               N:=Integer(Random(31));
              RandomInt:=N;
              While ReturnedRegType < 3 do
               Case ReturnedRegType of
                1: Begin
                    ReturnedRegType:=4;
                    If Application^.ExecDialog(New(PPINCheckDialog,
                                    Init(AParent,'PINCHECK_DLG'))) = id_OK
                     Then ReturnedRegType:=3;
                   End;
                2: Begin
                    ReturnedRegType:=4;
                    If Application^.ExecDialog(New(PCopyCheckDialog,
                                   Init(AParent,'COPYCHECK_DLG',
                                                CheckVal[RandomInt,1],
                                                CheckVal[RandomInt,2],
                                                CheckVal[RandomInt,3],
                                                RandomInt))) = id_OK
                     Then ReturnedRegType:=3;
                   End;
               End;

              If ReturnedRegType = 3
               then begin
                      {Put UserName as 3rd param}
                      StrPCopy(PCh,UserName);
                      CopyCheck:=WatchDog('Register',ProgramCheck,PCh);
                     end;

             End;
  Verify   : Begin
              {Put UserName as 3rd param}
              CopyCheck:=WatchDog('Validate',ProgramCheck,PCh);
              UserName:=StrPas(PCh);
             End;
 End;
End;
Constructor TFirstDialog.Init(AParent : PWindowsObject;AName : PChar);
begin
  TCenteredDialog.Init(AParent,AName,hc_OrderId);
end;

procedure TFirstDialog.SetupWindow;
var
  PCh : array[0..80] of char;
  Workstr : var80string;

begin
  TCenteredDialog.SetupWindow;
  GetWindowText(GetItemHandle(id_UserId),PCh,80);
  Workstr:=StrPas(PCh);
  Workstr:=Workstr + UserName;
  StrPCopy(PCh,WorkStr);
  SetWindowText(GetItemHandle(id_UserId),PCh);
  ShowWindow(GetItemHandle(id_PFM),sw_Hide);
  ShowWindow(GetItemHandle(id_PFMVNo),sw_Show);
  ShowWindow(GetItemHandle(id_Vno),sw_Hide);
  ShowWindow(GetItemHandle(id_UserId),sw_Show);
end;

procedure TFirstDialog.Initiate;
begin
  Show(sw_ShowNormal);
  SendMessage(HWindow,wm_activate,ma_noactivate,LongInt(0));
  SendMessage(Parent^.HWindow,wm_activate,ma_activate,LongInt(0));
end;

Constructor TUnregDlg.Init(AParent   : PWindowsObject;
                           AName     : PChar;
                           ItemsLeft : integer);
begin
  TCenteredDialog.Init(AParent,AName,hc_OrderId);
  _ItemsLeft:=ItemsLeft;
end;

procedure TUnregDlg.SetupWindow;
var
  PCh : array[0..50] of char;
  WorkStr : var4string;
begin
  TCenteredDialog.SetupWindow;
  Str(_ItemsLeft,WorkStr);
  StrPCopy(PCh,WorkStr);
  SetWindowText(GetItemHandle(id_ItemsLeft),PCh);
end;

procedure  TUnregDlg.IDCompleteReg(var Msg : TMessage);
begin
 If CopyCheck(@Self,Enroll)
  Then Begin
        Registered:=True;
        TCenteredDialog.OK(Msg);
       End;
end;

procedure  TUnregDlg.IDSendFee(var Msg : TMessage);
begin
 WinHelp(HWindow, HelpFileName, Help_Context,hc_OrderId);
end;

procedure  TUnregDlg.IDWarranty(var Msg : TMessage);
begin
 WinHelp(HWindow, HelpFileName, Help_Context,mb_Warranty);
end;

constructor TCopyCheckDialog .Init(AParent : PWindowsObject;AName:PChar;
                     Page,Line,Word : Integer;
                     WhichWord : Integer);
begin
  TCenteredDialog.Init(AParent,AName,hc_OrderId);
  N     := WhichWord;
  APage := Page;
  ALine := Line;
  AWord := Word;
end;

procedure TCopyCheckDialog.SetupWindow ;
var
  PCh : array[0..10] of char;
begin
  TCenteredDialog.SetupWindow;
  Str(APage,Pch);
  SetDlgItemText(HWindow,id_Page,PCh);
  Str(ALine,Pch);
  SetDlgItemText(HWindow,id_Line,PCh);
  Str(AWord,Pch);
  SetDlgItemText(HWindow,id_Word,PCh);
end;

procedure  TCopyCheckDialog.IDFlipReg(var Msg : TMessage);
begin
  ReturnedRegType:=1;  {Flip to PIN registration}
  TCenteredDialog.Cancel(Msg);
end;
procedure  TCopyCheckDialog.OK(var Msg : TMessage);
var
 proglock : string[11];
 PCh : array[0..35] of char;

begin
  GetDlgItemText(HWindow,id_PIN,PCh,35);
  ProgLock := StrPas(PCh);
  If ProgLock <> CheckWord[N]
   then Begin
         SetFocus(GetItemHandle(id_PIN));
         NoBlip;
         exit;
        End;
  GetDlgItemText(HWindow,id_Name,PCh,35);
  UserName := StrPas(PCh);

  If byte(UserName[0]) < 5
   then Begin
         SetFocus(GetItemHandle(id_Name));
         NoBlip;
         exit;
        End;
  UserPIN:=CalcPIN(UserName);
  YesBlip;
  TCenteredDialog.OK(Msg);
end;

constructor TPINCheckDialog .Init(AParent : PWindowsObject;AName:PChar);
begin
  TCenteredDialog.Init(AParent,AName,hc_OrderId);
  ActiveDialog:=PinCheckDlgId;
end;

procedure TPINCheckDialog.SetupWindow ;
begin
  TCenteredDialog.SetupWindow;
end;

procedure  TPINCheckDialog.IDFlipReg(var Msg : TMessage);
begin
  ReturnedRegType:=2;  {Flip to Manual registration}
  TCenteredDialog.Cancel(Msg);
end;
procedure  TPINCheckDialog.OK(var Msg : TMessage);
var
 PCh : array[0..35] of char;
 CalculatedPIN : var5string;

begin
  GetDlgItemText(HWindow,id_Name,PCh,35);
  UserName := StrPas(PCh);
  If byte(UserName[0]) < 5
   then Begin
         SetFocus(GetItemHandle(id_Name));
         NoBlip;
         exit;
        End;
  GetDlgItemText(HWindow,id_PIN,PCh,6);
  UserPIN := StrPas(PCh);

  CalculatedPIN:=CalcPIN(UserName);
  If not (UserPIN = CalculatedPIN)
   then Begin
         PCH[0]:=#0;
         SetDlgItemText(HWindow,id_PIN,PCh);
         SetFocus(GetItemHandle(id_PIN));
         NoBlip;
         exit;
        End;

  YesBlip;
  TCenteredDialog.OK(Msg);
end;

Function CalcPIN(InpName: var35string): var5string;

Const
  VersionChar = '1';

 Var
  Index         : integer;
  M,N,I  : byte;
  Hash   : longint;
  Table  : array[1..35] of integer;
  Arg           : var35string;
  CalculatedPIN : var5string;
  Workstr       : var1string;

 Begin
  N:=byte(InpName[0]) div 2;
  Arg:=VersionChar + Copy(InpName,1,N) +
        VersionChar + Copy(InpName,1+N,35) + VersionChar;
  Trim(Arg);
  M:=byte(Arg[0]);
  For N:=1 to M do                               {Upcase & special char conv}
   Begin
    Arg[N]:=UpCase(Char(Arg[N]));
    Case Byte(Arg[N]) of
      45 : Arg[N]:=' '; {-}
     133 : Arg[N]:='A'; {}
     130 : Arg[N]:='E'; {}
     138 : Arg[N]:='E'; {}
     135 : Arg[N]:='C'; {}
     151 : Arg[N]:='U'; {}
    End;
   End;
  For N := 1 to 35 do
   Table[N]:=0;
  N:=1;
  Hash:=0;
  Workstr:=' ';
  M:=1+byte(arg[0]);
  While (N < M) do
   Begin
    If arg[N] = ' '
     Then Workstr[1]:='0'
     Else If arg[N] in ['0'..'9']
           Then Workstr[1]:=arg[N]
           Else Workstr[1]:=Char((Byte(arg[N]) mod 10) + 48);
    Val(Workstr,Table[N],Code);
    Inc(N);
   End;
   Dec(N);
   M:=N;
   For I:=1 to M do
    Begin
     Case I of
      1,6,11,16,21 : Hash:=Hash+Table[N];
      2,7,12,17,22 : Hash:=Hash+(Table[N]*10);
      3,8,13,18,23 : Hash:=Hash+(Table[N]*100);
      4,9,14,19,24 : Hash:=Hash+(Table[N]*1000);
      5,10,15,20,25: Hash:=Hash+(Table[N]*10000);
     End;
     Dec(N);
    End;
   Hash:=Abs(Hash mod 100000);
   Str(Hash:5,CalculatedPIN);
   For N:= 1 to 5 do
    If CalculatedPIN[N] = ' '
     Then CalculatedPIN[N]:='0';
   CalcPIN:=CalculatedPIN;
 End;

end.
